#include <MacroPatternMatch.h>

#include "HROOTHistTH1D.h"
#include "HROOTHistTH1.h"
#include "HROOTHistTF1.h"
#include "HROOTCoreTObjArray.h"
#include "TH2.h"
#include "HROOTHistTH2.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )

#define IS_TH2_fill1_PROTECTED ()

TH1_DEF_VIRT(TH2)
TOBJECT_DEF_VIRT(TH2)
TATTLINE_DEF_VIRT(TH2)
TATTFILL_DEF_VIRT(TH2)
TATTMARKER_DEF_VIRT(TH2)
DELETABLE_DEF_VIRT(TH2)

TH2_DEF_VIRT(TH2)

TH2_DEF_NONVIRT(TH2)


