{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Hist.TH1D.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Hist.TH1D.RawType

import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayD.Interface
---- ============ ----



class (ITH1 a,ITArrayD a) => ITH1D a where

instance Existable TH1D where
  data Exist TH1D = forall a. (FPtr a, ITH1D a) => ETH1D a

upcastTH1D :: (FPtr a, ITH1D a) => a -> TH1D
upcastTH1D h = let fh = get_fptr h
                   fh2 :: ForeignPtr RawTH1D = castForeignPtr fh
               in cast_fptr_to_obj fh2

downcastTH1D :: (FPtr a, ITH1D a) => TH1D -> a 
downcastTH1D h = let fh = get_fptr h
                     fh2 = castForeignPtr fh
                 in cast_fptr_to_obj fh2
