{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Hist.TH2I.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Hist.TH2I.RawType

import HROOT.Hist.TH2.Interface
import HROOT.Core.TArrayI.Interface
---- ============ ----



class (ITH2 a,ITArrayI a) => ITH2I a where

instance Existable TH2I where
  data Exist TH2I = forall a. (FPtr a, ITH2I a) => ETH2I a

upcastTH2I :: (FPtr a, ITH2I a) => a -> TH2I
upcastTH2I h = let fh = get_fptr h
                   fh2 :: ForeignPtr RawTH2I = castForeignPtr fh
               in cast_fptr_to_obj fh2

downcastTH2I :: (FPtr a, ITH2I a) => TH2I -> a 
downcastTH2I h = let fh = get_fptr h
                     fh2 = castForeignPtr fh
                 in cast_fptr_to_obj fh2
