{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Hist.TH1I.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Hist.TH1I.RawType

import HROOT.Hist.TH1.Interface
import HROOT.Core.TArrayI.Interface
---- ============ ----



class (ITH1 a,ITArrayI a) => ITH1I a where

instance Existable TH1I where
  data Exist TH1I = forall a. (FPtr a, ITH1I a) => ETH1I a

upcastTH1I :: (FPtr a, ITH1I a) => a -> TH1I
upcastTH1I h = let fh = get_fptr h
                   fh2 :: ForeignPtr RawTH1I = castForeignPtr fh
               in cast_fptr_to_obj fh2

downcastTH1I :: (FPtr a, ITH1I a) => TH1I -> a 
downcastTH1I h = let fh = get_fptr h
                     fh2 = castForeignPtr fh
                 in cast_fptr_to_obj fh2
